if(!dojo._hasResource["com.ibm.data.MashupFileDataStore"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.data.MashupFileDataStore"] = true;
dojo.provide("com.ibm.data.MashupFileDataStore");

dojo.require( "com.ibm.data.CatalogMixin" );
dojo.require("com.ibm.data.MashupHubStore");

dojo.declare("com.ibm.data.MashupFileDataStore", 
		[com.ibm.data.MashupHubStore,com.ibm.data.CatalogMixin],
		{	
				/********************************/
				/**                            **/
				/**                            **/
				/**  catalog extension point   **/
				/**                            **/
				/**                            **/
				/********************************/
				
			mapItem: function(/*item*/item){
				var map = {};
				map.id = this.getEPResolvedValue(item, "id", null);
				map.label = this.getEPResolvedValue(item, "catalogName", this.bundle["shelf_untitled"]);
				map.description = this.getEPResolvedValue(item, "catalogDescription", "");
				map.tags = this.getEPResolvedValue(item, "catalogTags", "");
				map.rating = this.getEPResolvedValue(item, "catalogRating", 0.0);
				map.url = this.getEPResolvedValue(item, "catalogDownloadURL", "");
				map.type = this.getEPResolvedValue(item, "category", "");
				map.thumbnail = this.getValue(item, "catalogIcon", "");
				map.widgetParam = this.getEPResolvedValue(item, "catalogWidgetParam", "");
				map.onNewWire = this.getEPResolvedValue(item, "catalogOnNewWire", "");
				map.onAutoWire = this.getEPResolvedValue(item, "catalogAutoWire", "");
				map.permission = this.getEPResolvedValue(item, "catalogPermission", "");
				map.definitionURL = this.getValue(item, "catalogDefinitionURL", "");
				map.sandbox_user = this.getEPResolvedValue(item, "catalogSandboxUser", "false");
				map.sandbox_definition = this.getEPResolvedValue(item, "catalogSandboxUserDefinition", "false");
				map.icon = this.getValue(item, "catalogIcon", "false");
				map.widgetType = this.getEPResolvedValue(item, "catalogWidgetType", "");
				if (map.widgetType === "mm_OSGadget") {
					map.titles = this.getValue(item, "catalogTitles", null);
				}
				map.hubURL = this.url;
				map.isTrusted = map.sandbox_user == "true" ? false : true;
				if(map.widgetParam.length > 0) { map.prefsMapFcn = this.prefsMapFcn; }
				if (!map.thumbnail && builderConfig.builderPath) {
					if (item.store.namespace == "widget"){
						map["thumbnail"] = builderConfig.builderPath + "/images/generic_widget_icon.png";
					} else {
						map["thumbnail"] = builderConfig.builderPath + "/images/gray_generic_feed_icon.png";
					}						
				}
				return map;
			},
			
			prefsMapFcn: function(map){
				var pars = dojo.fromJson(map.widgetParam);
				var ret = {};
				for(var i in pars){
					ret[pars[i].itemName] = pars[i].itemValue;
				}
				return ret;
			},
				
			prepareQuery: function(keywordArgs) {
				if(keywordArgs.query.keywords) {
					keywordArgs.query.searchTerms = keywordArgs.query.keywords.join(" ");
					keywordArgs.query.searchType = "";
					delete keywordArgs.query.keywords;
				}
				else if(keywordArgs.query.tags && keywordArgs.query.tags.length > 0) {
					keywordArgs.query.searchTerms = keywordArgs.query.tags[0];
					keywordArgs.query.searchType = "tag";
					delete keywordArgs.query.tags;
				}
				else {
					keywordArgs.query.searchTerms = "*";
					keywordArgs.query.searchType = "";
				}
				
				if(keywordArgs.sort && keywordArgs.sort.length > 0) {
					switch(keywordArgs.sort[0].attribute) {
						case "date": 
							keywordArgs.query.sortBy = "updated";
							break;
						default:
							keywordArgs.query.sortBy = keywordArgs.sort[0].attribute;
					}
					keywordArgs.query.sortOrder = "asc";
					if(keywordArgs.sort[0].descending == true) {
						keywordArgs.query.sortOrder = "desc";
					}
				}
				
				if(keywordArgs.count) {
					keywordArgs.query.count = keywordArgs.count;
					if(keywordArgs.start == null) {
						keywordArgs.start = 0;
					}
					keywordArgs.query.startIndex = keywordArgs.start;
				}
				
				// NEVER get the feed from the cache, defect 16700
				if(!keywordArgs.queryOptions){
					keywordArgs.queryOptions = {};
				}
				keywordArgs.queryOptions.preventCache = true;
				
				return keywordArgs;
			},
			
			validateSelf: function(){
				// summary: validates this datastore, if it does not validate the source will not be used
				// returns true for validation and false otherwise
				var configSvc = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);
				var hubUrl = configSvc.getValue(com.ibm.mashups.enabler.services.ConfigConstants.HUB_URL);
				if(dojo.trim(ibmConfig["com.ibm.mashups.builder.contentShelf.mode"]) != "mashups" && hubUrl && this.url.indexOf("undefined") < 0) {
					return true;
				} else {
					return false;
				}
			}
});

}
