if(!dojo._hasResource["com.ibm.mashups.builder.model.ContextMenuItem"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.builder.model.ContextMenuItem"] = true;
dojo.provide("com.ibm.mashups.builder.model.ContextMenuItem");

/**
 * Defines the format for context menu items using simple object notation.  Items in this format
 * can be simple objects and are not restricted to instances of an interface, but must support
 * these properties.<br/>
 * { <br/>
 * &nbsp;&nbsp;&nbsp;&nbsp;<code>isSeparator</code>: true/false, whether this item is a menu separator,<br/>
 * &nbsp;&nbsp;&nbsp;&nbsp;<code>iconClass</code>: icon class name for menu item,<br/>
 * &nbsp;&nbsp;&nbsp;&nbsp;<code>description</code>: item description,<br/>
 * &nbsp;&nbsp;&nbsp;&nbsp;<code>title</code>: menu item title,<br/>
 * &nbsp;&nbsp;&nbsp;&nbsp;<code>localized</code>: com.ibm.mashups.enabler.Localized,contains titles and descriptions for all supported locales,   <br/> 
 * &nbsp;&nbsp;&nbsp;&nbsp;<code>enabled</code>: true/false, whether this item is enabled,<br/>
 * &nbsp;&nbsp;&nbsp;&nbsp;<code>id</code>: the id if listed, the id if listed, otherwise, null,<br/>
 * &nbsp;&nbsp;&nbsp;&nbsp;<code>ordinal</code>:  this could be null, which means it wasn't provided in the data, so should add it to the end of the context menu,<br/>
 * &nbsp;&nbsp;&nbsp;&nbsp;<code>actionCallBackFunction</code>: actionFnDefinedByMenuItem(){}<br/>
 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;By default the actionCallBackFunction is a zero-argument function, however, extensions may define
	 * other semantics that are used by context menu consumers that pass arguments.<br/>
 * }<br/>
 * <br/>
 * Any other properties may be added as extensions to be used by a context menu consumer.<br/>
 * It should not be expected that changes to any properties on an underlying context menu item that is returned by a context menu loader
 * will be surfaced in the user interface without first calling the context menu loader's <code>onChange</code> function.
 * @ibm-api
 * @ibm-spi
 * @ibm-module Builder
 */
dojo.declare("com.ibm.mashups.builder.model.ContextMenuItem", null, {
	
	/**
	 * Indicates whether or not this item is actually a separator between other items.  Typically,
	 * separator items do not contain many, if any, other properties at all, although extensions
	 * may define other semantics.
	 * @type Boolean
	 */
	isSeparator: false,
	
	/**
	 * A CSS class specified for this item.
	 * @type String
	 */
	iconClass: "",
	
	/**
	 * The description of the context menu item.  Defaults to the localized object's
	 * description if this is empty or <code>null</code>.
	 * @type String
	 */
	description: "",
	
	/**
	 * The title of the context menu item.  Defaults to the localized object's
	 * title if this is empty or <code>null</code>.
	 * @type String
	 */
	title: "",
	
	/**
	 * Localized object that provides access to a localized title and description for this item.
	 * @type com.ibm.mashups.enabler.Localized
	 */
	localized: null,
	
	/**
	 * Indicates whether or not this item is enabled.
	 * @type Boolean
	 */
	enabled: true,
	
	/**
	 * The String identifier of the context menu item.
	 * @type String
	 */
	id: "",

	
	/**
	 * Specifies the relative order in which this item appears in its context menu loader.
	 * @type Number
	 */
	ordinal: 0,
		
	
	/**
	 * The function to execute for this context menu item.  Execution time is dependent on the
	 * context menu consumer and is not defined by the API or necessarily limited to selecting
	 * or clicking an element in a user interface.<br/>
	 * By default the actionCallBackFunction is a zero-argument function, however, extensions may define
	 * other semantics that are used by context menu consumers that pass arguments.
	 * @type Function
	 */
	actionCallBackFunction: null,
	
	actionCallBackFunctionName: null
});

}
