if(!dojo._hasResource["com.ibm.mm.builder.dialog.PageSaveConfirmDialog"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.dialog.PageSaveConfirmDialog"] = true;
/**
 * @author Jarod (zhangpy@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.dialog.PageSaveConfirmDialog");

dojo.require("com.ibm.mm.builder.widget.CustomDialog");
dojo.require("com.ibm.mm.builder.utils.navigationUtil");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.declare("com.ibm.mm.builder.dialog.PageSaveConfirmDialog", [dijit._Widget, dijit._Templated], 
{
	frameDialog: null,
	
	callbackSave: null,
	
	callbackNotSave: null,
	
	callbackCancel: null,
	
	contentWarning: null,
	
	contentQuestion: null,
	
	btnSaveText: null,
	
	btnNotSaveText: null,
	
	btnCancelText: null,
	
	hideNotSave: false,
	
	savePageOnSave: true,
	
	frameWidth: "540px",
	
	templatePath: dojo.moduleUrl("com.ibm.mm.builder.dialog", "templates/PageSaveConfirmDialog.html"),
	
	postCreate: function(){
	
		var dialogParams = {
			id: "pageSaveConfirmDialog",
			title: com.ibm.mm.builder.coreWidgetsStrings.I_PAGE_SAVE_TITLE,
			displayCloseButton: true,
			hasRightBottomResizer: false,
			leftBarWidth: "0px",
			rightBarWidth: "0px"
		};
		
		this.frameDialog = new com.ibm.mm.builder.widget.CleanDialog(dojo.mixin(dialogParams, {
			nodeWidth: this.frameWidth,
			displayCloseButton: true,
			closeCallback: function(){
				this.destroy();
			}
		}));
		this.frameDialog.containerNode.appendChild(this.domNode);
		
		if(this.hideNotSave) {
			dojo.style(this.notSaveBtn, "display", "none");
		}
	},
	
	_onSaveWithKey: function(e){
		if (e.charCode === dojo.keys.SPACE || e.keyCode === dojo.keys.ENTER) {
			this._onSave(e);
		}
	},
	
	_onSave: function(){
		this.frameDialog.hide();
		if(this.savePageOnSave) {
			var eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");
			this.pageSavedHandle = eventService.subscribeEvent("com.ibm.mashups.builder.pageSaved", this, "_onSaveContinue");
			eventService.broadcastEvent("com.ibm.mashups.builder.savePage");
		}
		else {
			this.callbackSave && this.callbackSave(); 
		}
	},
	
	_onSaveContinue: function(){
    	if (this.pageSavedHandle) {
            var eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");
            eventService.unsubscribeEvent(this.pageSavedHandle);
            this.pageSavedHandle = null;
        }
        this.callbackSave && this.callbackSave();
	},
	
	_onNotSaveWithKey: function(e){
		if (e.charCode === dojo.keys.SPACE || e.keyCode === dojo.keys.ENTER) {
			this._onNotSave(e);
		}
	},
	
	_onNotSave: function(){
		this.frameDialog.hide();
		var runtimePage = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage();
		if (runtimePage) {
			// invalidate page
			var pageId = runtimePage.getID();
			var nm = com.ibm.mm.builder.utils.navigationUtil.getNavigationModel();
			var page = nm.find(pageId).start();
			page && nm.invalidate(page);
			
			// invalidate widget windows
			com.ibm.mashups.enabler.widget.Factory.getWidgetModel().cachedWindows = {};
			
			// cancel widget sizes
			var nsm = com.ibm.mashups.enabler.model.state.NavigationStateModelFactory.getNavigationStateModel();
			var layoutAccessor = com.ibm.mashups.enabler.model.state.AccessorFactory.getLayoutAccessor(nsm, pageId);
			layoutAccessor.setTemplateURL(null);
			
			// clean page
			runtimePage.setDirty(false);
		}
		this.callbackNotSave && this.callbackNotSave();
	},
	
	_onCancelWithKey: function(e){
		if (e.charCode === dojo.keys.SPACE || e.keyCode === dojo.keys.ENTER) {
			this._onCancel();
		}
	},
	
	_onCancel: function(){
		this.frameDialog.hide();
		this.callbackCancel && this.callbackCancel();
	},
	
	show: function(){
		this.frameDialog && this.frameDialog.show();
	}
});

}
