if(!dojo._hasResource["com.ibm.mm.catalog.CatalogPane"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.catalog.CatalogPane"] = true;
dojo.provide("com.ibm.mm.catalog.CatalogPane");

dojo.declare("com.ibm.mm.catalog.CatalogPane", null, {
	constructor: function() {
		this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.catalog.CatalogPane");
		this.LOG_LEVEL = com.ibm.mashups.enabler.logging.LogLevel.TRACE;
		this.dlg = {};
	},
	
	show: function(option, newWindow) {
		var hubServerUrl = "", paletteId = "";
		try {
			//get the hub server address
			hubServerUrl = this.getCatalogURL(option) || com.ibm.mm.catalog.hubUtil.getHubSecuredUrl();
			hubServerUrl = this._addOpenedInSuffix(hubServerUrl, newWindow);
		} catch (error) {
			if (this.LOGGER && this.LOGGER.isLoggable(this.LOG_LEVEL)) {
				this.LOGGER.severe("show", dojo.string.substitute(com.ibm.mm.builder.coreWidgetsMessages.E_MODE_SELECTOR_GET_CATALOG_1, [error.message]));
			}
			return;
		}
		//get the url to invoke MashupHub, it contains a parameter "serverUrl" for Mashups address
		if (hubServerUrl) {
			if (!newWindow) {
				if (!this.dlg[hubServerUrl]) {
					this.dlg[hubServerUrl] = com.ibm.mashups.builder.displayLMDialog(dojo.create("div"), {
						title: com.ibm.mm.builder.coreWidgetsStrings.I_CATALOG_PANE_TITLE,
						containerBackgroundColor: "white",
						nodeWidth: (0.9 * screen.availWidth + "px"),
						nodeHeight: (0.8 * screen.availHeight + "px"),
						displayCloseButton: true,
						closeCallback: dojo.hitch(this, function(){
							var iframes = dojo.query("iframe", this.dlg[hubServerUrl].domNode);
							if (iframes.length > 0) {
								var thisIframe = iframes[0];
								this.resetSrc(thisIframe,"javascript:false;");
							}
						})
					});
				} else {
					this.dlg[hubServerUrl].show();
				}
				var iframes = dojo.query("iframe", this.dlg[hubServerUrl].domNode);
				if (iframes.length > 0){
					this.resetSrc(iframes[0],hubServerUrl);
				} else {
	                dojo.query(dojo.create("iframe", {
	                    src: hubServerUrl
	                }, this.dlg[hubServerUrl].containerNode, "only")).style({
	                    width: "99.5%",
	                    height: "99%",
	                    border: "0 none"
	                });					
				}
			}
			else {
				var hubWin = window.open(hubServerUrl, "hub");
				if (hubWin) {
					hubWin.focus();
				}
			}
		}
	},
	
	resetSrc: function(/*DOMNode*/iframe, /*String*/src){
		try{
			var idoc;
			if(dojo.isIE || dojo.isWebKit > 521){
				idoc = iframe.contentWindow.document;
			}else if(dojo.isSafari){
				idoc = iframe.document;
			}else{
				idoc = iframe.contentWindow;
			}
			if(!idoc){
				iframe.location = src;
				return;
			}else{
				idoc.location.replace(src);
			}
		}catch(e){ 
			console.log("resetSrc: ", e); 
		}
	},
		
	_addOpenedInSuffix: function(url, newWindow) {		
		var hubServerUrl = url;
		if (!newWindow) {
			
			if (hubServerUrl.indexOf("?") != -1) {
				hubServerUrl = [hubServerUrl, "&"].join("");
			} 
			
			hubServerUrl = [hubServerUrl, "openedIn=dialog"].join("");
		}
		return hubServerUrl;
	},
	getCatalogURL: function(option) {
        dojo.require("dojox.encoding.base64");
        
        var mumUrl = ([window.location.protocol, "//", window.location.host, builderConfig.enablerPath].join("")),
            chars = [];
        for (var i = 0, l = mumUrl.length; i < l; i++) {
            chars.push(mumUrl.charCodeAt(i));
        }
        var mumUrl64 = dojox.encoding.base64.encode(chars);
		switch (option) {
			case com.ibm.mm.catalog.CATALOGCREATEFEEDUI: 
				return encodeURI([com.ibm.mm.catalog.hubUtil.getHubFeedCreationUrl(), "&serverUrl=", mumUrl64].join(""));
			case com.ibm.mm.catalog.CATALOGCREATEFEEDMASHUPUI:
				return encodeURI([com.ibm.mm.catalog.hubUtil.getHubFeedMashupCreationUrl(), "&serverUrl=", mumUrl64].join(""));
			case com.ibm.mm.catalog.CATALOGCREATENEWWIDGETUI:
				return encodeURI([com.ibm.mm.catalog.hubUtil.getHubWidgetCreationUrl(), "&serverUrl=", mumUrl64].join(""));
			default:
				var cs = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);
				var anonymousUser = cs.getValue("anonymousUser");
				var securityOff = cs.getValue("securityOff");
				if (anonymousUser || securityOff){
					return encodeURI([com.ibm.mm.catalog.hubUtil.getHubAnonymousUrl(), "?serverUrl=", mumUrl64].join(""));									
				} else {
					return encodeURI([com.ibm.mm.catalog.hubUtil.getHubSecuredUrl(), "?serverUrl=", mumUrl64].join(""));					
				}
		}
	}
});

com.ibm.mm.catalog.CatalogPane = new com.ibm.mm.catalog.CatalogPane();

com.ibm.mm.catalog.CATALOGUI = 0;
com.ibm.mm.catalog.CATALOGUI_NEW_WINDOW = 3;
com.ibm.mm.catalog.CATALOGCREATEFEEDUI = 1;
com.ibm.mm.catalog.CATALOGCREATEFEEDMASHUPUI = 2;
com.ibm.mm.catalog.CATALOGCREATENEWWIDGETUI = 4;

}
