dojo.provide("com.ibm.pb.dnd.layout.LayoutMashupRowSource");

dojo.require("com.ibm.pb.dnd.layout.LayoutRowSource");
dojo.require("com.ibm.mm.builder.dnd.QuickWireHelper");

dojo.declare("com.ibm.pb.dnd.layout.LayoutMashupRowSource", 
		[com.ibm.pb.dnd.layout.LayoutRowSource, com.ibm.mm.builder.dnd.QuickWireHelper], {
	
	layoutParser: com.ibm.pb.layout.LayoutParser,
	
	onDndCancel: function() {
		this.inherited(arguments);
		this.destroyAllQuickWireTarget();
	},
	
	onMouseMove: function(e){
		// summary:
		//		event processor for onmousemove
		// e: Event
		//		mouse event
		// Customization: add topPos
		if(this.isDragging && this.targetState == "Disabled"){ return; }
		dojo.dnd.Source.superclass.onMouseMove.call(this, e);
		var m = dojo.dnd.manager();
		if(!this.isDragging){
			if(this.mouseDown && this.isSource &&
					(Math.abs(e.pageX - this._lastX) > this.delay || Math.abs(e.pageY - this._lastY) > this.delay)){
				var nodes = this.getSelectedNodes();
				if(nodes.length){
					m.startDrag(this, nodes, this.copyState(dojo.isCopyKey(e), true));
				}
			}
		}
		if(this.isDragging){
			// calculate before/after
			var before = false;
			var topPos = -1;
			if(this.current){
				if(!this.targetBox || this.targetAnchor != this.current){
					this.targetBox = dojo.position(this.current, true);
				}
				if(this.horizontal){
					before = (e.pageX - this.targetBox.x) < (this.targetBox.w / 2);
					topPos = e.pageY - this.targetBox.y;
					
					// create QuickWireTarget when mouse over the handler
					if(this.targetAnchor) {
						var node = this.targetAnchor;
						var _id = this.layoutParser.extractID(node);
						if(topPos >= this.quickWireHandlerHeight) {
							this.destroyQuickWireTarget(_id);
						} else {
							if(this.quickWireHandlers[_id]) {
								// do nothing
							} else {
								this.createQuickWireTarget(_id);
							}
						}
					}
					// end of customization	
				}else{
					topPos = e.pageY - this.targetBox.y;
					before = topPos < (this.targetBox.h / 2);
				}
			}
			if(this.current != this.targetAnchor || before != this.before){
				this._markTargetAnchor(before);
				m.canDrop(!this.current || m.source != this || !(this.current.id in this.selection));
			}
		}
	}
	
});

com.ibm.pb.dnd.layout.LayoutMashupRowSource.creator = 
	dojo.hitch(com.ibm.pb.dnd.layout.LayoutMashupRowSource, 
		com.ibm.pb.dnd.layout.LayoutRowSource.creator);

com.ibm.pb.dnd.layout.LayoutMashupRowSource.withHandles = true;
