/* Copyright IBM Corp. 2013  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.Localized");

//<INTERFACE>
/**
 * Read-Only interface providing methods to obtain title and description of a
 * resource. Please note that title or description are only returned if they
 * are available in the requested locale. No fallback for locales is performed.
 * @ibm-api
 * @ibm-module Base
 */
dojo.declare("com.ibm.mashups.enabler.Localized", null, {
    /**
     * Returns an array containing the locales that are supported by this
     * object. The presence of a locale in this list does not mean that a title
     * <b>and</b> description is available, but rather that either one or both
     * are available in that locale.<br>
     * <br>
     * <b>Note:</b> Modifying the array does not change the supported locales.
     * @return {String[]} a list of locales defined for this object, returns an
     * empty array if no locales are supported. Can never be <code>null</code>.
     */
    getLocales: function(){
    },
    
    /**
     * Returns the title of this object in the given locale.
     * @param {String} locale the locale for which to retrieve the title,
     * must not be <code>null</code>.
     * @return {String} the title of this node in the given locale. If a title is not
     * available in the given locale, this method will return <code>null</code>.
     * It is up to the invoker of the method to implement an appropriate fallback mechanism.
     */
    getTitle: function(locale){
    },
    
    /**
     * Returns the titles of this object in a map (key: locale, value: title).
     *
     * @param {String} locale   (optional) the locale for which to retrieve the titles, can be <code>null</code>. If locale is null/omitted, all are returned.
     * @return {Object} the titles of this node in a locale<->title map. If a locale was given, the result will be a map containing only those locales with country specific matches (e.g. if you give a locale "pt", you might also get brazilian portugese ("pt-BR") - if you give a locale "zh-TW", you won't get "zh"). If there are no titles (matching the given locale), an empty object will be returned.
     *
     * @since 3.0
     */
    getTitles: function(){
    },
    
    /**
     * Returns the description of this object in the given locale.
     * @param {String} locale   the locale for which to retrieve the
     * description, must not be <code>null</code>.
     * @return {String} the description of this node in the given locale. If a
     * description is not available in the given locale, this method
     * will return <code>null</code>. It is up to the invoker of the
     * method to implement an appropriate fallback mechanism.
     */
    getDescription: function(locale){
    },
    
    /**
     * Returns the descriptions of this object in a map (key: locale, value: description).
     *
     * @param {String} locale   (optional) the locale for which to retrieve the descriptions, can be <code>null</code>. If locale is null/omitted, all are returned.
     * @return {Object} the descriptions of this node in a locale<->description map. If a locale was given, the result will be a map containing only those locales with country specific matches (e.g. if you give a locale "pt", you might also get brazilian portugese ("pt-BR") - if you give a locale "zh-TW", you won't get "zh"). If there are no descriptions (matching the given locale), an empty object will be returned.
     *
     * @since 3.0
     */
    getDescriptions: function(locale){
    }
});
//</INTERFACE>

dojo.require("com.ibm.mashups.enabler.ModifiableLocalized");
