/* Copyright IBM Corp. 2013  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.services.IdentificationService");

dojo.require("com.ibm.mashups.enabler.Identifiable");

//<INTERFACE>

/**
 * Interface to work with client side ids.
 * @ibm-spi
 * @ibm-module Base
 * @since 3.0
 */
dojo.declare("com.ibm.mashups.enabler.services.IdentificationService", null, {
    /**
     * Returns a new client side ID.
     * @return {String} client side id; never <code>null</code>.
     */
    createClientID: function() {
    },
    /**
     * This method attaches a client side id to make it know to the service
     * @param {Object} clientID client side id as string or Identifiable object
     * @return {void}
     * @since 3.0.0.1
     */
    attachClientID: function(clientID) {
    },
    /**
     * Releases an earlier through <tt>getClientID</tt> loaded client id.
     * @param {String} id the id to release
     * @return {void}
     */
    releaseClientID: function(id) {
    },
    /**
     * Checks whether the specified id is a client id of this IdentificationService
     * @param {String} id the id to check for client id
     * @return {boolean} <tt>true</tt> if the specified id is a client id <tt>false</tt> otherwise.
     */
    isClientID: function(id) {
    },
    /**
     * Checks whether the specified id is a server id generated by the underling server implementation
     * @param {String} id the id to check for server id
     * @return {boolean} <tt>true</tt> if the specified id is a server id <tt>false</tt> otherwise.
     */
    isServerID: function(id) {
    },
    /**
     * Checks whether the specified id is neither an client id nor an server id but is specified outside the mashup framework.
     *
     * @param {String} id the id to check for alien id
     * @return {boolean} <tt>true</tt> if the specified id is a alien id <tt>false</tt> otherwise.
     */
    isAlienID: function(id) {
    },
    /**
     * This method attaches a server side id to an existing client side id.
     * @param {Object} clientID client side id as string or Identifiable object
     * @param {Object} serverID server side id as string or Identifiable object
     * @return {void}
     */
    attachServerID: function(clientID, serverID) {
    },
    
    /**
     * Returns the attached server side id for any given client side id. Returns the
     * specified id, if it cannot be resolved.
     * @param {String} id the id to resolve
     * @return {String} id the resolved id
     */
    resolveID: function(id) {
    },
    
    /**
     * Returns the attached server side id for any given client side id. Returns the
     * specified id, if it cannot be resolved.
     * @param {String} id the id to resolve
     * @return {com.ibm.mashups.enabler.Identifiable} id the resolved id
     */
    resolveIdentifiable: function(id) {
    }
});
//</INTERFACE>

dojo.require("com.ibm.mm.enabler.services.IdentificationServiceImpl");
