# BEGIN COPYRIGHT
# Licensed Materials - Property of IBM
# 5724-M24
# Copyright IBM Corporation 2010. All Rights Reserved.
# US Government Users Restricted Rights- Use, duplication or disclosure
# restricted by GSA ADP Schedule Contract with IBM Corp.
# END COPYRIGHT

#This script can be called from a command-line wrapper script or from the profile upgrade framework.
#If called from the framework, then the System properties will hold the relevant parameters.
#If called from the command-line then the expected parameters are: 
#[dmgrHome, nodeName, serverName, clusterName]


from java.lang import System
import java.io.File as File;
import zipfile
import shutil

#*******************************************************************************************************
#
#*******************************************************************************************************
def convertServerToCluster(nodeName, serverName, clusterName):
  arr= '[-serverName "' + serverName + '" -nodeName "' + nodeName + '" -clusterName "' + clusterName + '"]'

  AdminTask.convertBusinessSpaceServerToCluster(arr)

  AdminConfig.save()
  
#enddef

#*******************************************************************************************************
#
#*******************************************************************************************************
def updateProperties(clusterName, configServiceDirpath):  
  arr= '[-clusterName "' + clusterName + '" -propertyDirectoryName "' + configServiceDirpath + '" -prefix "Mashups_"]'
  
  AdminTask.updatePropertyConfig(arr)

  AdminConfig.save()
#enddef

#*******************************************************************************************************
#
#*******************************************************************************************************
def deployApplications(clusterName, appDir):  
  arr= '[-clusterName "' + clusterName + '" -earDirectoryName "' + appDir + '" -appNameSuffix "_' + clusterName + '"]'

  AdminTask.deployMashupsEAR(arr)

  AdminConfig.save()
#enddef

#*******************************************************************************************************
#
#*******************************************************************************************************
def uninstallBusinessSpace(nodeName, serverName):
  arr= '[-serverName "' + serverName + '" -nodeName "' + nodeName + '"]'

  AdminTask.uninstallBusinessSpace(arr)

  AdminConfig.save()
#enddef

#*******************************************************************************************************
#This function converts path to unix style
#*******************************************************************************************************
def convertPathToUnixStyle(pathName):
  newPath = File(pathName);
  newPath = newPath.getAbsolutePath()
  return newPath.replace('\\',"/");
#endDef

#Main

#initialize the variables

print

dmgrHome = convertPathToUnixStyle(sys.argv[0])
nodeName = sys.argv[1]
serverName = sys.argv[2]
clusterName= sys.argv[3]

appDir = dmgrHome + '/temp/BusinessSpace/tempApps/' + nodeName + '/' + serverName
configServiceDirpath = dmgrHome + '/BusinessSpace/' + clusterName + '/mm.runtime.prof/config'

convertServerToCluster(nodeName, serverName, clusterName) 

updateProperties(clusterName, configServiceDirpath)

deployApplications(clusterName, appDir)

uninstallBusinessSpace(nodeName, serverName)

print

#end Main